//+------------------------------------------------------------------+
//|                                                    FS_Expert.mq4 |
//|                         Copyright 2013, DKeN (Alexandr Gavrilin) |
//|                                            http://sovetnikov.net |
//+------------------------------------------------------------------+
/*
  .
1.	 .
2.	     (  ).
3.	    .  0   .
4.	    .
5.	 .
6.	 .
7.	 .
8.	.  1-    .  2-  .  3- ,  
9.	.  1-  .  2-   .  3-,   .
10.	  (  ).
11.	 ,  ,   ( ).

*/
#property copyright "Copyright 2013, DKeN (Alexandr Gavrilin)"
#property link      "http://sovetnikov.net/"
#include <mt4lib.mqh>

extern string _1_0=" ";
extern string  cmt=""; //  
extern int     order_magic=20131211; //
extern double  slippage=5; //
extern double  order_lot=0.1; //
extern double  lot_procent=0; // 0 ,   %  )   100$ = 0.01 
extern int     MaxCount=4; // -  ,   -    
extern double  order_tp=120; // 
extern double  order_sl=30; // 
extern double  StopOut=30; //   ,      ., 0 -     
extern int     MaxStopToday=3; //-   ,        ,     ., 0 -    
extern double  pointForStart=10; //-          
extern string _lock=" ";
extern double  Profit=0; //     >=     
extern double  LockStep=20; // 0 -   
extern double  LockKoef=1.25;
extern string _2_0=" ";
/*     ,        */
bool DisplayFanStatus=true;
/*    ,       */
bool DisplayFan=true;
/*    timeframe'      ( , 0-        ) */
extern int Timeframe1=PERIOD_M1;
extern int Timeframe2=PERIOD_M5;
extern int Timeframe3=PERIOD_M15;
extern int Timeframe4=PERIOD_M30;
extern int Timeframe5=PERIOD_H1;
extern int Timeframe6=0;
extern int Timeframe7=0;
extern int Timeframe8=0;

/*   ,      */
extern datetime TrackingTime=0;
/*        */
extern bool Tracking=false;
/*         */
extern bool Sliding=true;
/*   ,      */
extern string SlidingSound="";
/*    ,  ,    (0-        ) */
extern int MA1=55;
extern int MA2=21;
extern int MA3=5;
extern int MA4=89;
extern int MA5=0;
extern int MA6=0;
extern int MA7=0;
extern int MA8=0;
/*       */
extern bool DisplayMA1=true;
extern bool DisplayMA2=true;
extern bool DisplayMA3=true;
extern bool DisplayMA4=true;
extern bool DisplayMA5=true;
extern bool DisplayMA6=true;
extern bool DisplayMA7=true;
extern bool DisplayMA8=true;
/*    */
extern string FontName="Wingdings";
/*   */
extern int FontSize=12;
/*          */
extern int PriceOnSymbol=108; // Circle
extern int PriceOffSymbol=32; // Space
/*        */
extern color PriceColor=LimeGreen;
/*     */
extern int FanWrongSymbol=117; // Diamond
extern int FanUpSymbol=233; // Up Arrow
extern int FanDownSymbol=234; // Down Arrow
/*     */
extern color FanWrongColor=DarkGray;
extern color FanUpColor=DodgerBlue;
extern color FanDownColor=OrangeRed;
extern int   MaxBars=100;
/*   (X)   (Y)     */
extern int X=0;
extern int Y=20;

extern string _3_0=" ";
extern bool    trailing_use=true; //
extern double  trailing_level=30; //  
extern double  trailing_offset=30; //   

extern bool    bu_use=true;//
extern double  bu_level=20; //  
extern double  bu_profit=1; //   

                            // 
bool check;
bool bWork=true;
double price_start=0;
// Tracking vertical line label and color
#define TRACKING_NAME ",  "
#define TRACKING_COLOR DarkGray
//----
string RowName[3]=
  {
   "  ",
   " ",
   "  "
  };
// Type of rendering codes
#define is_down    0
#define is_none    1
#define is_up      2
//----
int Timeframe[9];
string TimeframeNames[9];
int status[9],price_status[9];
int TimeframeInUse=0;
//----
int MAs[8];
int Xlat[8];
int MAsInUse=0;
//----
double MA1Buf[],MA2Buf[],MA3Buf[],MA4Buf[],MA5Buf[],MA6Buf[],MA7Buf[],MA8Buf[];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   check=false;
   bWork=true;
   order_set_slip(slippage);
   if(cmt=="") cmt=WindowExpertName();
   price_start=0;

   indicator_init();
//if(!IsDemo()) check=true;
//if(TimeCurrent()>StrToTime("2012.02_20 23:59")) check=true;//demo
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   indicator_deinit();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(!work_check(check)) return (0);
   string n=Symbol();

   int all=0,i,j,last_ticket=0,lock=0,t=0;
   double p,lot,profit,pt;
   bool bret;
   p=p(n);

//  
//       1  ,      1 ,      ,   (0   0),        $
//    lock,   ,               .

   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS)) continue;
      if(OrderMagicNumber()==order_magic && OrderSymbol()==n)
        {
/*
              
         */
         int main_id=StringToInteger(OrderComment());
         if(main_id>0) lock++;  //  

         if(LockStep>0)
           {
            last_ticket=OrderTicket();
            int type=OrderType();
            lot=OrderLots();

            if(main_id==0)
              {
               pt=order_OrderProfitPoint(OrderTicket());
               t=0;

               bool bFind=false;
               for(j=OrdersTotal()-1;j>=0;j--)
                 {
                  if(!OrderSelect(j,SELECT_BY_POS)) continue;
                  if(OrderMagicNumber()==order_magic && OrderSymbol()==n)
                    {
                         if(StringToInteger(OrderComment())==last_ticket){ bFind=true; break;} //     ???
                    }
                 }

               if(!bFind) //    
                 {
                  if(type==OP_BUY && pt<-LockStep)
                    {
                     t=order_OrderSendNDD(n,order_magic,OP_SELL,NLot(lot*LockKoef),-1,0,0,DoubleToString(last_ticket,0),0,clrRed);
                    }

                  if(type==OP_SELL && pt<-LockStep)
                    {
                     t=order_OrderSendNDD(n,order_magic,OP_BUY,NLot(lot*LockKoef),-1,0,0,DoubleToString(last_ticket,0),0,clrBlue);
                    }
                 }

               if(t>0) order_OrderModify(last_ticket,-1,0,0);
              }

            bret=OrderSelect(last_ticket,SELECT_BY_TICKET);
           }

        }
     }

//    
   profit=0;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS)) continue;
      if(OrderMagicNumber()==order_magic && OrderSymbol()==n)
        {
         if((OrderType()==OP_BUY || OrderType()==OP_SELL) && StringToInteger(OrderComment())==0) all++;
         profit+=OrderProfit()+OrderSwap()+OrderCommission(); //  

        }
     }

   Comment("Profit: ",DoubleToString(profit,2));  
   if(bar_isNew(0,PERIOD_D1)) bWork=true; //     

   if(NormalizeDouble(100*profit/AccountBalance(),1)>=NormalizeDouble(StopOut,1) && StopOut>0)
     {
      bWork=false; // ?    
      Print(" StopOut,         .");
      order_OrderCloseAll(n,order_magic,-1); //    
      return (0);
     }

   if(NormalizeDouble(profit,2)>=NormalizeDouble(Profit,2) && lock>0)
     {
      bWork=false; // ?    
      Print("Lock:  Profit,         .");
      order_OrderCloseAll(n,order_magic,-1); //    
      return (0);
     }

   if(bu_use && lock==0) bu(n,order_magic,bu_level,bu_profit);
   if(trailing_use && lock==0) trailing_esmart(n,order_magic,trailing_level,trailing_offset,0,0,0,0,5);

   datetime NewTrackingTime=TrackingTime;
   static datetime time=0;
//----
   if(time==0)
     {
      if(TrackingTime==0)
         TrackingTime=Time[0];
      i=((TimeDay(TrackingTime)*24+TimeHour(TrackingTime))*60+TimeMinute(TrackingTime))*60+TimeSeconds(TrackingTime);
      TrackingTime-=i;
      i/=60;
      i-=i%Period();
      TrackingTime+=i*60;
      if(Tracking)
         ObjectSet(TRACKING_NAME,OBJPROP_TIME1,TrackingTime);
      else
         NewTrackingTime=TrackingTime;
     }
//-----
   if(Tracking)
      NewTrackingTime=ObjectGet(TRACKING_NAME,OBJPROP_TIME1);
/*        -       */
   if(NewTrackingTime!=TrackingTime || (CurTime()-TrackingTime)/60<Period() || time!=Time[0])
     {
      if(DisplayFanStatus)
         for(i=0; i<TimeframeInUse; i++)
           {
            bool Up=true,Down=true;
            bool PriceUp=true,PriceDown=true;
            int LocalShift=iBarShift(Symbol(),Timeframe[i],NewTrackingTime+(Period()-1)*60);
            double PrevMA=0;
            //----
            for(j=0; j<MAsInUse; j++)
              {
               double MA=iMA(Symbol(),Timeframe[i],MAs[Xlat[j]],0,MODE_EMA,PRICE_CLOSE,LocalShift);
               if(j>0) { if(Up && PrevMA<MA) Up=false; if(Down && PrevMA>MA) Down=false; }
               if(PriceUp && MA>iClose(Symbol(),Timeframe[i],LocalShift)) PriceUp=false;
               if(PriceDown && MA<iClose(Symbol(),Timeframe[i],LocalShift)) PriceDown=false;
               PrevMA=MA;
              }
            //----
            if(Up) {UpdateFanStatus(i,is_up); status[i]=1;} else if(Down){ UpdateFanStatus(i,is_down); status[i]=-1;} else{ UpdateFanStatus(i,is_none); status[i]=0;}
            if(PriceUp){ UpdatePriceStatus(i,is_up); price_status[i]=1;}else if(PriceDown){ UpdatePriceStatus(i,is_down); price_status[i]=-1;}else{ UpdatePriceStatus(i,is_none); price_status[i]=0;}

           }
      if(DisplayFan)
         for(i=MaxBars-1; i>=0; i--)
           {
            if(DisplayMA1 && MA1 > 0) MA1Buf[i]=iMA(Symbol(), 0, MA1, 0, MODE_SMMA, PRICE_TYPICAL, i);
            if(DisplayMA2 && MA2 > 0) MA2Buf[i]=iMA(Symbol(), 0, MA2, 0, MODE_SMMA, PRICE_TYPICAL, i);
            if(DisplayMA3 && MA3 > 0) MA3Buf[i]=iMA(Symbol(), 0, MA3, 0, MODE_SMMA, PRICE_TYPICAL, i);
            if(DisplayMA4 && MA4 > 0) MA4Buf[i]=iMA(Symbol(), 0, MA4, 0, MODE_EMA, PRICE_CLOSE, i);
            if(DisplayMA5 && MA5 > 0) MA5Buf[i]=iMA(Symbol(), 0, MA5, 0, MODE_EMA, PRICE_CLOSE, i);
            if(DisplayMA6 && MA6 > 0) MA6Buf[i]=iMA(Symbol(), 0, MA6, 0, MODE_EMA, PRICE_CLOSE, i);
            if(DisplayMA7 && MA7 > 0) MA7Buf[i]=iMA(Symbol(), 0, MA7, 0, MODE_EMA, PRICE_CLOSE, i);
            if(DisplayMA8 && MA8 > 0) MA8Buf[i]=iMA(Symbol(), 0, MA8, 0, MODE_EMA, PRICE_CLOSE, i);
           }
      //----
      if(time!=Time[0])
        {
         if(Sliding && time!=0)
            NewTrackingTime+=Time[0] - time;
         time=Time[0];
        }
      if(Tracking && NewTrackingTime!=TrackingTime)
         ObjectSet(TRACKING_NAME,OBJPROP_TIME1,NewTrackingTime);
      if(StringLen(SlidingSound)!=0 && NewTrackingTime!=TrackingTime)
         PlaySound(SlidingSound);
      TrackingTime=NewTrackingTime;
     }

   int b=0,s=0;
   for(i=0;i<TimeframeInUse;i++)
     {
      if(price_status[i]==1 && status[i]==1) b++;
      if(price_status[i]==-1 && status[i]==-1) s++;
     }

   if(b==TimeframeInUse || s==TimeframeInUse)
     {
      if(b==TimeframeInUse && price_start==0.0) price_start=Ask;
      if(s==TimeframeInUse && price_start==0.0) price_start=Bid;
        }else{
      price_start=0; //  ..  
     }

   int minus=0; //-  
   for(i=OrdersHistoryTotal()-1;i>=0;i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
      if(OrderMagicNumber()==order_magic && OrderSymbol()==n && OrderOpenTime()>=iTime(n,PERIOD_D1,0))
        {
         if(OrderProfit()<0) minus++;

        }
     }

   if(minus>=MaxStopToday && MaxStopToday>0) bWork=false; //      

   if(all<MaxCount && price_start>0 && bWork && order_lot>0)
     {

      lot=order_lot;

      if(lot_procent>0) lot=MathFloor(AccountBalance()*lot_procent/100)*0.01;

      if(b==TimeframeInUse && NormalizeDouble((Ask-price_start)/p,1)>=pointForStart)
        {
         order_OrderSendNDD(n,order_magic,OP_BUY,lot,-1,order_sl,order_tp,cmt,0,Blue);
         price_start=0;
        }

      if(s==TimeframeInUse && NormalizeDouble((price_start-Bid)/p,1)>=pointForStart)
        {
         order_OrderSendNDD(n,order_magic,OP_SELL,lot,-1,order_sl,order_tp,cmt,0,Red);
         price_start=0;
        }
     }
//Comment(DoubleToStr(Ask-price_start,5));  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string LabelName(int i,int j) { return(RowName[j]+"("+(i+1)+"): "+TimeframeNames[i]); }
//----
int symcolor[3][2];
int syms[3][2];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateFanStatus(int i,int how)
  {
   string s=" ";
   ObjectSetText(LabelName(i,1),StringSetChar(s,0,symcolor[how][0]),FontSize,FontName,symcolor[how][1]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdatePriceStatus(int i,int how)
  {
   string s=" ";
   ObjectSetText(LabelName(i,0),StringSetChar(s,0,syms[how][0]),FontSize,FontName,PriceColor);
   ObjectSetText(LabelName(i,2),StringSetChar(s,0,syms[how][1]),FontSize,FontName,PriceColor);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitTimeframe(int &P[],int PV)
  {
   if(PV!=0)
     {
      switch(PV)
        {
         case PERIOD_M1:  TimeframeNames[TimeframeInUse]="M1";  break;
         case PERIOD_M5:  TimeframeNames[TimeframeInUse]="M5";  break;
         case PERIOD_M15: TimeframeNames[TimeframeInUse]="M15"; break;
         case PERIOD_M30: TimeframeNames[TimeframeInUse]="M30"; break;
         case PERIOD_H1:  TimeframeNames[TimeframeInUse]="H1";  break;
         case PERIOD_H4:  TimeframeNames[TimeframeInUse]="H4";  break;
         case PERIOD_D1:  TimeframeNames[TimeframeInUse]="D1";  break;
         case PERIOD_W1:  TimeframeNames[TimeframeInUse]="W1";  break;
         case PERIOD_MN1: TimeframeNames[TimeframeInUse]="MN1"; break;
         default: return;
        }
      P[TimeframeInUse]=PV; TimeframeInUse++;
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitMAs(int &P[],int MA) { if(MA>0) { P[MAsInUse]=MA; MAsInUse++; } }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int indicator_init()
  {
   int i,j;

   ArrayResize(MA1Buf,MaxBars);
   ArrayResize(MA2Buf,MaxBars);
   ArrayResize(MA3Buf,MaxBars);
   ArrayResize(MA4Buf,MaxBars);
   ArrayResize(MA5Buf,MaxBars);
   ArrayResize(MA6Buf,MaxBars);
   ArrayResize(MA7Buf,MaxBars);
   ArrayResize(MA8Buf,MaxBars);

   ArraySetAsSeries(MA1Buf,true); ArraySetAsSeries(MA2Buf,true); ArraySetAsSeries(MA3Buf,true); ArraySetAsSeries(MA4Buf,true);
   ArraySetAsSeries(MA5Buf,true); ArraySetAsSeries(MA6Buf,true); ArraySetAsSeries(MA7Buf,true); ArraySetAsSeries(MA8Buf,true);

   if(DisplayFanStatus)
     {
      syms[0][0]=PriceOffSymbol; syms[0][1]=PriceOnSymbol;
      syms[1][0]=PriceOffSymbol; syms[1][1]=PriceOffSymbol;
      syms[2][0]=PriceOnSymbol; syms[2][1]=PriceOffSymbol;
      InitTimeframe(Timeframe,Timeframe1); InitTimeframe(Timeframe,Timeframe2); InitTimeframe(Timeframe,Timeframe3); InitTimeframe(Timeframe,Timeframe4);
      InitTimeframe(Timeframe,Timeframe5); InitTimeframe(Timeframe,Timeframe6); InitTimeframe(Timeframe,Timeframe7); InitTimeframe(Timeframe,Timeframe8);

      InitMAs(MAs,MA1); InitMAs(MAs,MA2); InitMAs(MAs,MA3); InitMAs(MAs,MA4);
      InitMAs(MAs,MA5); InitMAs(MAs,MA6); InitMAs(MAs,MA7); InitMAs(MAs,MA8);
      for(i=0; i < MAsInUse; i++) Xlat[i]=i;
      for(i=0; i < MAsInUse - 1; i++)
         for(j=i+1; j<MAsInUse; j++)
               if(MAs[Xlat[i]]>MAs[Xlat[j]]) { int k=Xlat[j]; Xlat[j]=Xlat[i]; Xlat[i]=k; }
      for(i=0; i<TimeframeInUse; i++)
         for(j=0; j<3; j++)
           {
            string s=LabelName(i,j);
            //----
            ObjectCreate(s,OBJ_LABEL,0,0,0);
            ObjectSet(s,OBJPROP_XDISTANCE,(TimeframeInUse-i-1)*13*FontSize/10+2*FontSize/10+X);
            ObjectSet(s,OBJPROP_YDISTANCE,j*16*FontSize/10+3*FontSize/10+Y);
            ObjectSet(s,OBJPROP_BACK,true);
            ObjectSet(s,OBJPROP_CORNER,1);
            ObjectSetText(s," ",FontSize,FontName,Black);
           }
      //----
      if(Tracking)
        {
         ObjectCreate(TRACKING_NAME,OBJ_VLINE,0,TrackingTime,0);
         ObjectSet(TRACKING_NAME,OBJPROP_COLOR,TRACKING_COLOR);
        }
     }
//----
   if(DisplayFan)
     {
      string IndicatorName="FanSimple(";
      symcolor[0][0]=FanDownSymbol; symcolor[0][1]=FanDownColor;
      symcolor[1][0]=FanWrongSymbol; symcolor[1][1]=FanWrongColor;
      symcolor[2][0]=FanUpSymbol; symcolor[2][1]=FanUpColor;
      //----
      if(DisplayMA1 && MA1 > 0) IndicatorName=IndicatorName + MA1; if(DisplayMA2 && MA2 > 0) IndicatorName=IndicatorName + ", " + MA2;
      if(DisplayMA3 && MA3 > 0) IndicatorName=IndicatorName + ", " + MA3; if(DisplayMA4 && MA4 > 0) IndicatorName=IndicatorName + ", " + MA4;
      if(DisplayMA5 && MA5 > 0) IndicatorName=IndicatorName + ", " + MA5; if(DisplayMA6 && MA6 > 0) IndicatorName=IndicatorName + ", " + MA6;
      if(DisplayMA7 && MA7 > 0) IndicatorName=IndicatorName + ", " + MA7; if(DisplayMA8 && MA8 > 0) IndicatorName=IndicatorName + ", " + MA8;

      //----

      for(i=MaxBars-1; i>=0; i--)
        {
         MA1Buf[i]=0; MA2Buf[i]=0; MA3Buf[i]=0; MA4Buf[i]=0; MA5Buf[i]=0; MA6Buf[i]=0; MA7Buf[i]=0; MA8Buf[i]=0;
        }
     }

   if(TimeframeInUse>0)
     {
      ArrayResize(status,TimeframeInUse);
      ArrayInitialize(status,0);
      ArrayResize(price_status,TimeframeInUse);
      ArrayInitialize(price_status,0);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int indicator_deinit()
  {
   for(int i=0; i<TimeframeInUse; i++)
      for(int j=0; j<3; j++)
         ObjectDelete(LabelName(i,j));
//----
   if(Tracking)
      ObjectDelete(TRACKING_NAME);
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
